module MyToyRobot 
  class CLI  
    attr_reader :simulator
    def initialize 
      table = MyToyRobot::Table.new(5, 5)
      @simulator = MyToyRobot::Simulator.new(table)
    end 

    def load_commands(file)
      File.readlines(file).map do |command|
        MyToyRobot::Command.process(command)
      end
    end  

    def run(commands) 
      commands.each do |command, *args|
        simulator.send(command, *args)
      end 
    end
  end 
end